com.amazonaws.services.machinelearning.model

## Class MLModel

- java.lang.Object
- - com.amazonaws.services.machinelearning.model.MLModel

All Implemented Interfaces:
  Serializable, Cloneable

    public class MLModel
    extends Object
    implements Serializable, Cloneable

Represents the output of a `GetMLModel` operation.

The content consists of the detailed metadata and the current status of the `MLModel`.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`MLModel()`

### Method Summary

All Methods Instance Methods Concrete Methods
`MLModel` `addTrainingParametersEntry(String key, String value)`
`MLModel` `clearTrainingParametersEntries()` Removes all the entries added into TrainingParameters.
`MLModel` `clone()`
`boolean` `equals(Object obj)`
`String` `getAlgorithm()` The algorithm used to train the `MLModel`.
`Long` `getComputeTime()`
`Date` `getCreatedAt()` The time that the `MLModel` was created.
`String` `getCreatedByIamUser()` The AWS user account from which the `MLModel` was created.
`RealtimeEndpointInfo` `getEndpointInfo()` The current endpoint of the `MLModel`.
`Date` `getFinishedAt()`
`String` `getInputDataLocationS3()` The location of the data file or directory in Amazon Simple Storage Service (Amazon S3).
`Date` `getLastUpdatedAt()` The time of the most recent edit to the `MLModel`.
`String` `getMessage()` A description of the most recent details about accessing the `MLModel`.
`String` `getMLModelId()` The ID assigned to the `MLModel` at creation.
`String` `getMLModelType()` Identifies the `MLModel` category.
`String` `getName()` A user-supplied name or description of the `MLModel`.
`Float` `getScoreThreshold()`
`Date` `getScoreThresholdLastUpdatedAt()` The time of the most recent edit to the `ScoreThreshold`.
`Long` `getSizeInBytes()`
`Date` `getStartedAt()`
`String` `getStatus()` The current status of an `MLModel`.
`String` `getTrainingDataSourceId()` The ID of the training `DataSource`.
`Map<String,String>` `getTrainingParameters()` A list of the training parameters in the `MLModel`.
`int` `hashCode()`
`void` `setAlgorithm(Algorithm algorithm)` The algorithm used to train the `MLModel`.
`void` `setAlgorithm(String algorithm)` The algorithm used to train the `MLModel`.
`void` `setComputeTime(Long computeTime)`
`void` `setCreatedAt(Date createdAt)` The time that the `MLModel` was created.
`void` `setCreatedByIamUser(String createdByIamUser)` The AWS user account from which the `MLModel` was created.
`void` `setEndpointInfo(RealtimeEndpointInfo endpointInfo)` The current endpoint of the `MLModel`.
`void` `setFinishedAt(Date finishedAt)`
`void` `setInputDataLocationS3(String inputDataLocationS3)` The location of the data file or directory in Amazon Simple Storage Service (Amazon S3).
`void` `setLastUpdatedAt(Date lastUpdatedAt)` The time of the most recent edit to the `MLModel`.
`void` `setMessage(String message)` A description of the most recent details about accessing the `MLModel`.
`void` `setMLModelId(String mLModelId)` The ID assigned to the `MLModel` at creation.
`void` `setMLModelType(MLModelType mLModelType)` Identifies the `MLModel` category.
`void` `setMLModelType(String mLModelType)` Identifies the `MLModel` category.
`void` `setName(String name)` A user-supplied name or description of the `MLModel`.
`void` `setScoreThreshold(Float scoreThreshold)`
`void` `setScoreThresholdLastUpdatedAt(Date scoreThresholdLastUpdatedAt)` The time of the most recent edit to the `ScoreThreshold`.
`void` `setSizeInBytes(Long sizeInBytes)`
`void` `setStartedAt(Date startedAt)`
`void` `setStatus(EntityStatus status)` The current status of an `MLModel`.
`void` `setStatus(String status)` The current status of an `MLModel`.
`void` `setTrainingDataSourceId(String trainingDataSourceId)` The ID of the training `DataSource`.
`void` `setTrainingParameters(Map<String,String> trainingParameters)` A list of the training parameters in the `MLModel`.
`String` `toString()` Returns a string representation of this object; useful for testing and debugging.
`MLModel` `withAlgorithm(Algorithm algorithm)` The algorithm used to train the `MLModel`.
`MLModel` `withAlgorithm(String algorithm)` The algorithm used to train the `MLModel`.
`MLModel` `withComputeTime(Long computeTime)`
`MLModel` `withCreatedAt(Date createdAt)` The time that the `MLModel` was created.
`MLModel` `withCreatedByIamUser(String createdByIamUser)` The AWS user account from which the `MLModel` was created.
`MLModel` `withEndpointInfo(RealtimeEndpointInfo endpointInfo)` The current endpoint of the `MLModel`.
`MLModel` `withFinishedAt(Date finishedAt)`
`MLModel` `withInputDataLocationS3(String inputDataLocationS3)` The location of the data file or directory in Amazon Simple Storage Service (Amazon S3).
`MLModel` `withLastUpdatedAt(Date lastUpdatedAt)` The time of the most recent edit to the `MLModel`.
`MLModel` `withMessage(String message)` A description of the most recent details about accessing the `MLModel`.
`MLModel` `withMLModelId(String mLModelId)` The ID assigned to the `MLModel` at creation.
`MLModel` `withMLModelType(MLModelType mLModelType)` Identifies the `MLModel` category.
`MLModel` `withMLModelType(String mLModelType)` Identifies the `MLModel` category.
`MLModel` `withName(String name)` A user-supplied name or description of the `MLModel`.
`MLModel` `withScoreThreshold(Float scoreThreshold)`
`MLModel` `withScoreThresholdLastUpdatedAt(Date scoreThresholdLastUpdatedAt)` The time of the most recent edit to the `ScoreThreshold`.
`MLModel` `withSizeInBytes(Long sizeInBytes)`
`MLModel` `withStartedAt(Date startedAt)`
`MLModel` `withStatus(EntityStatus status)` The current status of an `MLModel`.
`MLModel` `withStatus(String status)` The current status of an `MLModel`.
`MLModel` `withTrainingDataSourceId(String trainingDataSourceId)` The ID of the training `DataSource`.
`MLModel` `withTrainingParameters(Map<String,String> trainingParameters)` A list of the training parameters in the `MLModel`.

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### MLModel

    public MLModel()

### Method Detail

#### setMLModelId

    public void setMLModelId(String mLModelId)

The ID assigned to the `MLModel` at creation.

Parameters:
  `mLModelId` - The ID assigned to the `MLModel` at creation.

#### getMLModelId

    public String getMLModelId()

The ID assigned to the `MLModel` at creation.

Returns:
  The ID assigned to the `MLModel` at creation.

#### withMLModelId

    public MLModel withMLModelId(String mLModelId)

The ID assigned to the `MLModel` at creation.

Parameters:
  `mLModelId` - The ID assigned to the `MLModel` at creation.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setTrainingDataSourceId

    public void setTrainingDataSourceId(String trainingDataSourceId)

The ID of the training `DataSource`. The `CreateMLModel` operation uses the `TrainingDataSourceId`.

Parameters:
  `trainingDataSourceId` - The ID of the training `DataSource`. The `CreateMLModel` operation uses the `TrainingDataSourceId`.

#### getTrainingDataSourceId

    public String getTrainingDataSourceId()

The ID of the training `DataSource`. The `CreateMLModel` operation uses the `TrainingDataSourceId`.

Returns:
  The ID of the training `DataSource`. The `CreateMLModel` operation uses the `TrainingDataSourceId`.

#### withTrainingDataSourceId

    public MLModel withTrainingDataSourceId(String trainingDataSourceId)

The ID of the training `DataSource`. The `CreateMLModel` operation uses the `TrainingDataSourceId`.

Parameters:
  `trainingDataSourceId` - The ID of the training `DataSource`. The `CreateMLModel` operation uses the `TrainingDataSourceId`.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setCreatedByIamUser

    public void setCreatedByIamUser(String createdByIamUser)

The AWS user account from which the `MLModel` was created. The account type can be either an AWS root account or an AWS Identity and Access Management (IAM) user account.

Parameters:
  `createdByIamUser` - The AWS user account from which the `MLModel` was created. The account type can be either an AWS root account or an AWS Identity and Access Management (IAM) user account.

#### getCreatedByIamUser

    public String getCreatedByIamUser()

The AWS user account from which the `MLModel` was created. The account type can be either an AWS root account or an AWS Identity and Access Management (IAM) user account.

Returns:
  The AWS user account from which the `MLModel` was created. The account type can be either an AWS root account or an AWS Identity and Access Management (IAM) user account.

#### withCreatedByIamUser

    public MLModel withCreatedByIamUser(String createdByIamUser)

The AWS user account from which the `MLModel` was created. The account type can be either an AWS root account or an AWS Identity and Access Management (IAM) user account.

Parameters:
  `createdByIamUser` - The AWS user account from which the `MLModel` was created. The account type can be either an AWS root account or an AWS Identity and Access Management (IAM) user account.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setCreatedAt

    public void setCreatedAt(Date createdAt)

The time that the `MLModel` was created. The time is expressed in epoch time.

Parameters:
  `createdAt` - The time that the `MLModel` was created. The time is expressed in epoch time.

#### getCreatedAt

    public Date getCreatedAt()

The time that the `MLModel` was created. The time is expressed in epoch time.

Returns:
  The time that the `MLModel` was created. The time is expressed in epoch time.

#### withCreatedAt

    public MLModel withCreatedAt(Date createdAt)

The time that the `MLModel` was created. The time is expressed in epoch time.

Parameters:
  `createdAt` - The time that the `MLModel` was created. The time is expressed in epoch time.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setLastUpdatedAt

    public void setLastUpdatedAt(Date lastUpdatedAt)

The time of the most recent edit to the `MLModel`. The time is expressed in epoch time.

Parameters:
  `lastUpdatedAt` - The time of the most recent edit to the `MLModel`. The time is expressed in epoch time.

#### getLastUpdatedAt

    public Date getLastUpdatedAt()

The time of the most recent edit to the `MLModel`. The time is expressed in epoch time.

Returns:
  The time of the most recent edit to the `MLModel`. The time is expressed in epoch time.

#### withLastUpdatedAt

    public MLModel withLastUpdatedAt(Date lastUpdatedAt)

The time of the most recent edit to the `MLModel`. The time is expressed in epoch time.

Parameters:
  `lastUpdatedAt` - The time of the most recent edit to the `MLModel`. The time is expressed in epoch time.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setName

    public void setName(String name)

A user-supplied name or description of the `MLModel`.

Parameters:
  `name` - A user-supplied name or description of the `MLModel`.

#### getName

    public String getName()

A user-supplied name or description of the `MLModel`.

Returns:
  A user-supplied name or description of the `MLModel`.

#### withName

    public MLModel withName(String name)

A user-supplied name or description of the `MLModel`.

Parameters:
  `name` - A user-supplied name or description of the `MLModel`.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setStatus

    public void setStatus(String status)

The current status of an `MLModel`. This element can have one of the following values:

- `PENDING` - Amazon Machine Learning (Amazon ML) submitted a request to create an `MLModel`.
- `INPROGRESS` - The creation process is underway.
- `FAILED` - The request to create an `MLModel` didn't run to completion. The model isn't usable.
- `COMPLETED` - The creation process completed successfully.
- `DELETED` - The `MLModel` is marked as deleted. It isn't usable.

Parameters:
  `status` - The current status of an `MLModel`. This element can have one of the following values:
  - `PENDING` - Amazon Machine Learning (Amazon ML) submitted a request to create an `MLModel`.
  - `INPROGRESS` - The creation process is underway.
  - `FAILED` - The request to create an `MLModel` didn't run to completion. The model isn't usable.
  - `COMPLETED` - The creation process completed successfully.
  - `DELETED` - The `MLModel` is marked as deleted. It isn't usable.
See Also:
  `EntityStatus`

#### getStatus

    public String getStatus()

The current status of an `MLModel`. This element can have one of the following values:

- `PENDING` - Amazon Machine Learning (Amazon ML) submitted a request to create an `MLModel`.
- `INPROGRESS` - The creation process is underway.
- `FAILED` - The request to create an `MLModel` didn't run to completion. The model isn't usable.
- `COMPLETED` - The creation process completed successfully.
- `DELETED` - The `MLModel` is marked as deleted. It isn't usable.

Returns:
  The current status of an `MLModel`. This element can have one of the following values:
  - `PENDING` - Amazon Machine Learning (Amazon ML) submitted a request to create an `MLModel`.
  - `INPROGRESS` - The creation process is underway.
  - `FAILED` - The request to create an `MLModel` didn't run to completion. The model isn't usable.
  - `COMPLETED` - The creation process completed successfully.
  - `DELETED` - The `MLModel` is marked as deleted. It isn't usable.
See Also:
  `EntityStatus`

#### withStatus

    public MLModel withStatus(String status)

The current status of an `MLModel`. This element can have one of the following values:

- `PENDING` - Amazon Machine Learning (Amazon ML) submitted a request to create an `MLModel`.
- `INPROGRESS` - The creation process is underway.
- `FAILED` - The request to create an `MLModel` didn't run to completion. The model isn't usable.
- `COMPLETED` - The creation process completed successfully.
- `DELETED` - The `MLModel` is marked as deleted. It isn't usable.

Parameters:
  `status` - The current status of an `MLModel`. This element can have one of the following values:
  - `PENDING` - Amazon Machine Learning (Amazon ML) submitted a request to create an `MLModel`.
  - `INPROGRESS` - The creation process is underway.
  - `FAILED` - The request to create an `MLModel` didn't run to completion. The model isn't usable.
  - `COMPLETED` - The creation process completed successfully.
  - `DELETED` - The `MLModel` is marked as deleted. It isn't usable.
Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `EntityStatus`

#### setStatus

    public void setStatus(EntityStatus status)

The current status of an `MLModel`. This element can have one of the following values:

- `PENDING` - Amazon Machine Learning (Amazon ML) submitted a request to create an `MLModel`.
- `INPROGRESS` - The creation process is underway.
- `FAILED` - The request to create an `MLModel` didn't run to completion. The model isn't usable.
- `COMPLETED` - The creation process completed successfully.
- `DELETED` - The `MLModel` is marked as deleted. It isn't usable.

Parameters:
  `status` - The current status of an `MLModel`. This element can have one of the following values:
  - `PENDING` - Amazon Machine Learning (Amazon ML) submitted a request to create an `MLModel`.
  - `INPROGRESS` - The creation process is underway.
  - `FAILED` - The request to create an `MLModel` didn't run to completion. The model isn't usable.
  - `COMPLETED` - The creation process completed successfully.
  - `DELETED` - The `MLModel` is marked as deleted. It isn't usable.
See Also:
  `EntityStatus`

#### withStatus

    public MLModel withStatus(EntityStatus status)

The current status of an `MLModel`. This element can have one of the following values:

- `PENDING` - Amazon Machine Learning (Amazon ML) submitted a request to create an `MLModel`.
- `INPROGRESS` - The creation process is underway.
- `FAILED` - The request to create an `MLModel` didn't run to completion. The model isn't usable.
- `COMPLETED` - The creation process completed successfully.
- `DELETED` - The `MLModel` is marked as deleted. It isn't usable.

Parameters:
  `status` - The current status of an `MLModel`. This element can have one of the following values:
  - `PENDING` - Amazon Machine Learning (Amazon ML) submitted a request to create an `MLModel`.
  - `INPROGRESS` - The creation process is underway.
  - `FAILED` - The request to create an `MLModel` didn't run to completion. The model isn't usable.
  - `COMPLETED` - The creation process completed successfully.
  - `DELETED` - The `MLModel` is marked as deleted. It isn't usable.
Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `EntityStatus`

#### setSizeInBytes

    public void setSizeInBytes(Long sizeInBytes)

Parameters:
  `sizeInBytes` -

#### getSizeInBytes

    public Long getSizeInBytes()

Returns:

#### withSizeInBytes

    public MLModel withSizeInBytes(Long sizeInBytes)

Parameters:
  `sizeInBytes` -
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setEndpointInfo

    public void setEndpointInfo(RealtimeEndpointInfo endpointInfo)

The current endpoint of the `MLModel`.

Parameters:
  `endpointInfo` - The current endpoint of the `MLModel`.

#### getEndpointInfo

    public RealtimeEndpointInfo getEndpointInfo()

The current endpoint of the `MLModel`.

Returns:
  The current endpoint of the `MLModel`.

#### withEndpointInfo

    public MLModel withEndpointInfo(RealtimeEndpointInfo endpointInfo)

The current endpoint of the `MLModel`.

Parameters:
  `endpointInfo` - The current endpoint of the `MLModel`.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### getTrainingParameters

    public Map<String,String> getTrainingParameters()

A list of the training parameters in the `MLModel`. The list is implemented as a map of key-value pairs.

The following is the current set of training parameters:

- `sgd.maxMLModelSizeInBytes` - The maximum allowed size of the model. Depending on the input data, the size of the model might affect its performance.

  The value is an integer that ranges from `100000` to `2147483648`. The default value is `33554432`.

- `sgd.maxPasses` - The number of times that the training process traverses the observations to build the `MLModel`. The value is an integer that ranges from `1` to `10000`. The default value is `10`.

- `sgd.shuffleType` - Whether Amazon ML shuffles the training data. Shuffling the data improves a model's ability to find the optimal solution for a variety of data types. The valid values are `auto` and `none`. The default value is `none`.

- `sgd.l1RegularizationAmount` - The coefficient regularization L1 norm, which controls overfitting the data by penalizing large coefficients. This parameter tends to drive coefficients to zero, resulting in sparse feature set. If you use this parameter, start by specifying a small value, such as `1.0E-08`.

  The value is a double that ranges from `0` to `MAX_DOUBLE`. The default is to not use L1 normalization. This parameter can't be used when `L2` is specified. Use this parameter sparingly.

- `sgd.l2RegularizationAmount` - The coefficient regularization L2 norm, which controls overfitting the data by penalizing large coefficients. This tends to drive coefficients to small, nonzero values. If you use this parameter, start by specifying a small value, such as `1.0E-08`.

  The value is a double that ranges from `0` to `MAX_DOUBLE`. The default is to not use L2 normalization. This parameter can't be used when `L1` is specified. Use this parameter sparingly.

Returns:
  A list of the training parameters in the `MLModel`. The list is implemented as a map of key-value pairs.

  The following is the current set of training parameters:

  - `sgd.maxMLModelSizeInBytes` - The maximum allowed size of the model. Depending on the input data, the size of the model might affect its performance.

    The value is an integer that ranges from `100000` to `2147483648`. The default value is `33554432`.

  - `sgd.maxPasses` - The number of times that the training process traverses the observations to build the `MLModel`. The value is an integer that ranges from `1` to `10000`. The default value is `10`.

  - `sgd.shuffleType` - Whether Amazon ML shuffles the training data. Shuffling the data improves a model's ability to find the optimal solution for a variety of data types. The valid values are `auto` and `none`. The default value is `none`.

  - `sgd.l1RegularizationAmount` - The coefficient regularization L1 norm, which controls overfitting the data by penalizing large coefficients. This parameter tends to drive coefficients to zero, resulting in sparse feature set. If you use this parameter, start by specifying a small value, such as `1.0E-08`.

    The value is a double that ranges from `0` to `MAX_DOUBLE`. The default is to not use L1 normalization. This parameter can't be used when `L2` is specified. Use this parameter sparingly.

  - `sgd.l2RegularizationAmount` - The coefficient regularization L2 norm, which controls overfitting the data by penalizing large coefficients. This tends to drive coefficients to small, nonzero values. If you use this parameter, start by specifying a small value, such as `1.0E-08`.

    The value is a double that ranges from `0` to `MAX_DOUBLE`. The default is to not use L2 normalization. This parameter can't be used when `L1` is specified. Use this parameter sparingly.

#### setTrainingParameters

    public void setTrainingParameters(Map<String,String> trainingParameters)

A list of the training parameters in the `MLModel`. The list is implemented as a map of key-value pairs.

The following is the current set of training parameters:

- `sgd.maxMLModelSizeInBytes` - The maximum allowed size of the model. Depending on the input data, the size of the model might affect its performance.

  The value is an integer that ranges from `100000` to `2147483648`. The default value is `33554432`.

- `sgd.maxPasses` - The number of times that the training process traverses the observations to build the `MLModel`. The value is an integer that ranges from `1` to `10000`. The default value is `10`.

- `sgd.shuffleType` - Whether Amazon ML shuffles the training data. Shuffling the data improves a model's ability to find the optimal solution for a variety of data types. The valid values are `auto` and `none`. The default value is `none`.

- `sgd.l1RegularizationAmount` - The coefficient regularization L1 norm, which controls overfitting the data by penalizing large coefficients. This parameter tends to drive coefficients to zero, resulting in sparse feature set. If you use this parameter, start by specifying a small value, such as `1.0E-08`.

  The value is a double that ranges from `0` to `MAX_DOUBLE`. The default is to not use L1 normalization. This parameter can't be used when `L2` is specified. Use this parameter sparingly.

- `sgd.l2RegularizationAmount` - The coefficient regularization L2 norm, which controls overfitting the data by penalizing large coefficients. This tends to drive coefficients to small, nonzero values. If you use this parameter, start by specifying a small value, such as `1.0E-08`.

  The value is a double that ranges from `0` to `MAX_DOUBLE`. The default is to not use L2 normalization. This parameter can't be used when `L1` is specified. Use this parameter sparingly.

Parameters:
  `trainingParameters` - A list of the training parameters in the `MLModel`. The list is implemented as a map of key-value pairs.

  The following is the current set of training parameters:

  - `sgd.maxMLModelSizeInBytes` - The maximum allowed size of the model. Depending on the input data, the size of the model might affect its performance.

    The value is an integer that ranges from `100000` to `2147483648`. The default value is `33554432`.

  - `sgd.maxPasses` - The number of times that the training process traverses the observations to build the `MLModel`. The value is an integer that ranges from `1` to `10000`. The default value is `10`.

  - `sgd.shuffleType` - Whether Amazon ML shuffles the training data. Shuffling the data improves a model's ability to find the optimal solution for a variety of data types. The valid values are `auto` and `none`. The default value is `none`.

  - `sgd.l1RegularizationAmount` - The coefficient regularization L1 norm, which controls overfitting the data by penalizing large coefficients. This parameter tends to drive coefficients to zero, resulting in sparse feature set. If you use this parameter, start by specifying a small value, such as `1.0E-08`.

    The value is a double that ranges from `0` to `MAX_DOUBLE`. The default is to not use L1 normalization. This parameter can't be used when `L2` is specified. Use this parameter sparingly.

  - `sgd.l2RegularizationAmount` - The coefficient regularization L2 norm, which controls overfitting the data by penalizing large coefficients. This tends to drive coefficients to small, nonzero values. If you use this parameter, start by specifying a small value, such as `1.0E-08`.

    The value is a double that ranges from `0` to `MAX_DOUBLE`. The default is to not use L2 normalization. This parameter can't be used when `L1` is specified. Use this parameter sparingly.

#### withTrainingParameters

    public MLModel withTrainingParameters(Map<String,String> trainingParameters)

A list of the training parameters in the `MLModel`. The list is implemented as a map of key-value pairs.

The following is the current set of training parameters:

- `sgd.maxMLModelSizeInBytes` - The maximum allowed size of the model. Depending on the input data, the size of the model might affect its performance.

  The value is an integer that ranges from `100000` to `2147483648`. The default value is `33554432`.

- `sgd.maxPasses` - The number of times that the training process traverses the observations to build the `MLModel`. The value is an integer that ranges from `1` to `10000`. The default value is `10`.

- `sgd.shuffleType` - Whether Amazon ML shuffles the training data. Shuffling the data improves a model's ability to find the optimal solution for a variety of data types. The valid values are `auto` and `none`. The default value is `none`.

- `sgd.l1RegularizationAmount` - The coefficient regularization L1 norm, which controls overfitting the data by penalizing large coefficients. This parameter tends to drive coefficients to zero, resulting in sparse feature set. If you use this parameter, start by specifying a small value, such as `1.0E-08`.

  The value is a double that ranges from `0` to `MAX_DOUBLE`. The default is to not use L1 normalization. This parameter can't be used when `L2` is specified. Use this parameter sparingly.

- `sgd.l2RegularizationAmount` - The coefficient regularization L2 norm, which controls overfitting the data by penalizing large coefficients. This tends to drive coefficients to small, nonzero values. If you use this parameter, start by specifying a small value, such as `1.0E-08`.

  The value is a double that ranges from `0` to `MAX_DOUBLE`. The default is to not use L2 normalization. This parameter can't be used when `L1` is specified. Use this parameter sparingly.

Parameters:
  `trainingParameters` - A list of the training parameters in the `MLModel`. The list is implemented as a map of key-value pairs.

  The following is the current set of training parameters:

  - `sgd.maxMLModelSizeInBytes` - The maximum allowed size of the model. Depending on the input data, the size of the model might affect its performance.

    The value is an integer that ranges from `100000` to `2147483648`. The default value is `33554432`.

  - `sgd.maxPasses` - The number of times that the training process traverses the observations to build the `MLModel`. The value is an integer that ranges from `1` to `10000`. The default value is `10`.

  - `sgd.shuffleType` - Whether Amazon ML shuffles the training data. Shuffling the data improves a model's ability to find the optimal solution for a variety of data types. The valid values are `auto` and `none`. The default value is `none`.

  - `sgd.l1RegularizationAmount` - The coefficient regularization L1 norm, which controls overfitting the data by penalizing large coefficients. This parameter tends to drive coefficients to zero, resulting in sparse feature set. If you use this parameter, start by specifying a small value, such as `1.0E-08`.

    The value is a double that ranges from `0` to `MAX_DOUBLE`. The default is to not use L1 normalization. This parameter can't be used when `L2` is specified. Use this parameter sparingly.

  - `sgd.l2RegularizationAmount` - The coefficient regularization L2 norm, which controls overfitting the data by penalizing large coefficients. This tends to drive coefficients to small, nonzero values. If you use this parameter, start by specifying a small value, such as `1.0E-08`.

    The value is a double that ranges from `0` to `MAX_DOUBLE`. The default is to not use L2 normalization. This parameter can't be used when `L1` is specified. Use this parameter sparingly.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### addTrainingParametersEntry

    public MLModel addTrainingParametersEntry(String key,
                                              String value)

#### clearTrainingParametersEntries

    public MLModel clearTrainingParametersEntries()

Removes all the entries added into TrainingParameters.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setInputDataLocationS3

    public void setInputDataLocationS3(String inputDataLocationS3)

The location of the data file or directory in Amazon Simple Storage Service (Amazon S3).

Parameters:
  `inputDataLocationS3` - The location of the data file or directory in Amazon Simple Storage Service (Amazon S3).

#### getInputDataLocationS3

    public String getInputDataLocationS3()

The location of the data file or directory in Amazon Simple Storage Service (Amazon S3).

Returns:
  The location of the data file or directory in Amazon Simple Storage Service (Amazon S3).

#### withInputDataLocationS3

    public MLModel withInputDataLocationS3(String inputDataLocationS3)

The location of the data file or directory in Amazon Simple Storage Service (Amazon S3).

Parameters:
  `inputDataLocationS3` - The location of the data file or directory in Amazon Simple Storage Service (Amazon S3).
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setAlgorithm

    public void setAlgorithm(String algorithm)

The algorithm used to train the `MLModel`. The following algorithm is supported:

- `SGD` -- Stochastic gradient descent. The goal of `SGD` is to minimize the gradient of the loss function.

Parameters:
  `algorithm` - The algorithm used to train the `MLModel`. The following algorithm is supported:
  - `SGD` -- Stochastic gradient descent. The goal of `SGD` is to minimize the gradient of the loss function.
See Also:
  `Algorithm`

#### getAlgorithm

    public String getAlgorithm()

The algorithm used to train the `MLModel`. The following algorithm is supported:

- `SGD` -- Stochastic gradient descent. The goal of `SGD` is to minimize the gradient of the loss function.

Returns:
  The algorithm used to train the `MLModel`. The following algorithm is supported:
  - `SGD` -- Stochastic gradient descent. The goal of `SGD` is to minimize the gradient of the loss function.
See Also:
  `Algorithm`

#### withAlgorithm

    public MLModel withAlgorithm(String algorithm)

The algorithm used to train the `MLModel`. The following algorithm is supported:

- `SGD` -- Stochastic gradient descent. The goal of `SGD` is to minimize the gradient of the loss function.

Parameters:
  `algorithm` - The algorithm used to train the `MLModel`. The following algorithm is supported:
  - `SGD` -- Stochastic gradient descent. The goal of `SGD` is to minimize the gradient of the loss function.
Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `Algorithm`

#### setAlgorithm

    public void setAlgorithm(Algorithm algorithm)

The algorithm used to train the `MLModel`. The following algorithm is supported:

- `SGD` -- Stochastic gradient descent. The goal of `SGD` is to minimize the gradient of the loss function.

Parameters:
  `algorithm` - The algorithm used to train the `MLModel`. The following algorithm is supported:
  - `SGD` -- Stochastic gradient descent. The goal of `SGD` is to minimize the gradient of the loss function.
See Also:
  `Algorithm`

#### withAlgorithm

    public MLModel withAlgorithm(Algorithm algorithm)

The algorithm used to train the `MLModel`. The following algorithm is supported:

- `SGD` -- Stochastic gradient descent. The goal of `SGD` is to minimize the gradient of the loss function.

Parameters:
  `algorithm` - The algorithm used to train the `MLModel`. The following algorithm is supported:
  - `SGD` -- Stochastic gradient descent. The goal of `SGD` is to minimize the gradient of the loss function.
Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `Algorithm`

#### setMLModelType

    public void setMLModelType(String mLModelType)

Identifies the `MLModel` category. The following are the available types:

- `REGRESSION` - Produces a numeric result. For example, "What price should a house be listed at?"
- `BINARY` - Produces one of two possible results. For example, "Is this a child-friendly web site?".
- `MULTICLASS` - Produces one of several possible results. For example, "Is this a HIGH-, LOW-, or MEDIUM-risk trade?".

Parameters:
  `mLModelType` - Identifies the `MLModel` category. The following are the available types:
  - `REGRESSION` - Produces a numeric result. For example, "What price should a house be listed at?"
  - `BINARY` - Produces one of two possible results. For example, "Is this a child-friendly web site?".
  - `MULTICLASS` - Produces one of several possible results. For example, "Is this a HIGH-, LOW-, or MEDIUM-risk trade?".
See Also:
  `MLModelType`

#### getMLModelType

    public String getMLModelType()

Identifies the `MLModel` category. The following are the available types:

- `REGRESSION` - Produces a numeric result. For example, "What price should a house be listed at?"
- `BINARY` - Produces one of two possible results. For example, "Is this a child-friendly web site?".
- `MULTICLASS` - Produces one of several possible results. For example, "Is this a HIGH-, LOW-, or MEDIUM-risk trade?".

Returns:
  Identifies the `MLModel` category. The following are the available types:
  - `REGRESSION` - Produces a numeric result. For example, "What price should a house be listed at?"
  - `BINARY` - Produces one of two possible results. For example, "Is this a child-friendly web site?".
  - `MULTICLASS` - Produces one of several possible results. For example, "Is this a HIGH-, LOW-, or MEDIUM-risk trade?".
See Also:
  `MLModelType`

#### withMLModelType

    public MLModel withMLModelType(String mLModelType)

Identifies the `MLModel` category. The following are the available types:

- `REGRESSION` - Produces a numeric result. For example, "What price should a house be listed at?"
- `BINARY` - Produces one of two possible results. For example, "Is this a child-friendly web site?".
- `MULTICLASS` - Produces one of several possible results. For example, "Is this a HIGH-, LOW-, or MEDIUM-risk trade?".

Parameters:
  `mLModelType` - Identifies the `MLModel` category. The following are the available types:
  - `REGRESSION` - Produces a numeric result. For example, "What price should a house be listed at?"
  - `BINARY` - Produces one of two possible results. For example, "Is this a child-friendly web site?".
  - `MULTICLASS` - Produces one of several possible results. For example, "Is this a HIGH-, LOW-, or MEDIUM-risk trade?".
Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `MLModelType`

#### setMLModelType

    public void setMLModelType(MLModelType mLModelType)

Identifies the `MLModel` category. The following are the available types:

- `REGRESSION` - Produces a numeric result. For example, "What price should a house be listed at?"
- `BINARY` - Produces one of two possible results. For example, "Is this a child-friendly web site?".
- `MULTICLASS` - Produces one of several possible results. For example, "Is this a HIGH-, LOW-, or MEDIUM-risk trade?".

Parameters:
  `mLModelType` - Identifies the `MLModel` category. The following are the available types:
  - `REGRESSION` - Produces a numeric result. For example, "What price should a house be listed at?"
  - `BINARY` - Produces one of two possible results. For example, "Is this a child-friendly web site?".
  - `MULTICLASS` - Produces one of several possible results. For example, "Is this a HIGH-, LOW-, or MEDIUM-risk trade?".
See Also:
  `MLModelType`

#### withMLModelType

    public MLModel withMLModelType(MLModelType mLModelType)

Identifies the `MLModel` category. The following are the available types:

- `REGRESSION` - Produces a numeric result. For example, "What price should a house be listed at?"
- `BINARY` - Produces one of two possible results. For example, "Is this a child-friendly web site?".
- `MULTICLASS` - Produces one of several possible results. For example, "Is this a HIGH-, LOW-, or MEDIUM-risk trade?".

Parameters:
  `mLModelType` - Identifies the `MLModel` category. The following are the available types:
  - `REGRESSION` - Produces a numeric result. For example, "What price should a house be listed at?"
  - `BINARY` - Produces one of two possible results. For example, "Is this a child-friendly web site?".
  - `MULTICLASS` - Produces one of several possible results. For example, "Is this a HIGH-, LOW-, or MEDIUM-risk trade?".
Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `MLModelType`

#### setScoreThreshold

    public void setScoreThreshold(Float scoreThreshold)

Parameters:
  `scoreThreshold` -

#### getScoreThreshold

    public Float getScoreThreshold()

Returns:

#### withScoreThreshold

    public MLModel withScoreThreshold(Float scoreThreshold)

Parameters:
  `scoreThreshold` -
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setScoreThresholdLastUpdatedAt

    public void setScoreThresholdLastUpdatedAt(Date scoreThresholdLastUpdatedAt)

The time of the most recent edit to the `ScoreThreshold`. The time is expressed in epoch time.

Parameters:
  `scoreThresholdLastUpdatedAt` - The time of the most recent edit to the `ScoreThreshold`. The time is expressed in epoch time.

#### getScoreThresholdLastUpdatedAt

    public Date getScoreThresholdLastUpdatedAt()

The time of the most recent edit to the `ScoreThreshold`. The time is expressed in epoch time.

Returns:
  The time of the most recent edit to the `ScoreThreshold`. The time is expressed in epoch time.

#### withScoreThresholdLastUpdatedAt

    public MLModel withScoreThresholdLastUpdatedAt(Date scoreThresholdLastUpdatedAt)

The time of the most recent edit to the `ScoreThreshold`. The time is expressed in epoch time.

Parameters:
  `scoreThresholdLastUpdatedAt` - The time of the most recent edit to the `ScoreThreshold`. The time is expressed in epoch time.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setMessage

    public void setMessage(String message)

A description of the most recent details about accessing the `MLModel`.

Parameters:
  `message` - A description of the most recent details about accessing the `MLModel`.

#### getMessage

    public String getMessage()

A description of the most recent details about accessing the `MLModel`.

Returns:
  A description of the most recent details about accessing the `MLModel`.

#### withMessage

    public MLModel withMessage(String message)

A description of the most recent details about accessing the `MLModel`.

Parameters:
  `message` - A description of the most recent details about accessing the `MLModel`.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setComputeTime

    public void setComputeTime(Long computeTime)

Parameters:
  `computeTime` -

#### getComputeTime

    public Long getComputeTime()

Returns:

#### withComputeTime

    public MLModel withComputeTime(Long computeTime)

Parameters:
  `computeTime` -
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setFinishedAt

    public void setFinishedAt(Date finishedAt)

Parameters:
  `finishedAt` -

#### getFinishedAt

    public Date getFinishedAt()

Returns:

#### withFinishedAt

    public MLModel withFinishedAt(Date finishedAt)

Parameters:
  `finishedAt` -
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setStartedAt

    public void setStartedAt(Date startedAt)

Parameters:
  `startedAt` -

#### getStartedAt

    public Date getStartedAt()

Returns:

#### withStartedAt

    public MLModel withStartedAt(Date startedAt)

Parameters:
  `startedAt` -
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### toString

    public String toString()

Returns a string representation of this object; useful for testing and debugging.

Overrides:
  `toString` in class `Object`
Returns:
  A string representation of this object.
See Also:
  `Object.toString()`

#### equals

    public boolean equals(Object obj)

Overrides:
  `equals` in class `Object`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### clone

    public MLModel clone()

Overrides:
  `clone` in class `Object`